#include "WinMain.h"

#include "Logger.h"

#include <iostream>
#include <tchar.h>

#ifdef  _DEBUG

std::wstring windowstitle{ L"First Window (DBG)" };

#else

std::wstring windowstitle{ L"First Window" };

#endif //  _DEBUG

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	case WM_CREATE:

		return 0;

	case WM_QUIT:
	case WM_DESTROY:
	case WM_CLOSE:
		PostQuitMessage(0);

		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

WMainProg::WMainProg() {
}

WMainProg::~WMainProg() {
	DestroyWindow(MainWnd);
	hInst = nullptr;
}

bool WMainProg::Create(WMainClass wmc) {
	WNDCLASSEX WndClassEx{};

	std::wstring classstitle{ windowstitle };

	hInst = GetModuleHandle(nullptr);

	WndClassEx.cbSize = sizeof(WNDCLASSEX);
	WndClassEx.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	WndClassEx.lpfnWndProc = static_cast<WNDPROC> (MainWndProc);
	WndClassEx.hInstance = hInst;
	WndClassEx.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClassEx.lpszClassName = classstitle.c_str();

	Error(RegisterClassEx(&WndClassEx));
		
	MainWnd = CreateWindowEx(NULL, classstitle.c_str(), windowstitle.c_str(), WS_OVERLAPPEDWINDOW, 0, 0, wmc.Width, wmc.Height, nullptr, nullptr, hInst, nullptr);

	Error(MainWnd);

	ShowWindow(MainWnd, SW_NORMAL);
	UpdateWindow(MainWnd);
	SetFocus(MainWnd);

	Start();
	
	MainLoop();
	
	return true;
}

int WMainProg::MainLoop() {

	while (1) {
		if (PeekMessage(&uMsg, NULL, 0, 0, PM_REMOVE)) {
			TranslateMessage(&uMsg);
			DispatchMessage(&uMsg);

			if (uMsg.message == WM_QUIT) {
				break;
			}

			wndproc(uMsg);
		}

		Loop();
	}

	return static_cast<int> (uMsg.wParam);
}